import "dart:math" as m;

class Property {
  Property(num this._value);

  factory Property.createFromCrossover(Property first, Property second) {
    var value = (first.value + second.value) / 2.0;
    return new Property(value);
  }
  num _value;

  num get value => this._value;
  set value(num v) => this._value = v;

  num mutate_problem(num vector) {
    m.Random r = new m.Random();

    var res = vector + r.nextDouble();

    return res;
  }

  void mutate() {
    var r = mutate_problem(this.value);
    this.value = r;
  }
}

class PropertyWithStrategy extends Property {
  ///
  PropertyWithStrategy(num this._value, num this._deviation) : super(_value);

  factory PropertyWithStrategy.simpleCreate() {
    return new PropertyWithStrategy(100, 80);
  }

  factory PropertyWithStrategy.createFromCrossover(
      PropertyWithStrategy first, PropertyWithStrategy second) {
    var value = (first.value + second.value) / 2.0;
    var deviation = (first.value + second.value) / 2.0;
    return new PropertyWithStrategy(value, deviation);
  }
  @override
  num _value;
  @override
  num get value => this._value;
  @override
  set value(num v) => this._value = v;

  num _deviation;

  num get deviation => this._deviation;
  set deviation(num d) => this._deviation = d;

  @override
  String toString() {
    return """Value  ${this.value} Deviation ${this.deviation} """;
  }

  num mutateStrategy(num stdev) {
    m.Random r = new m.Random();
    num stdchild = stdev * m.exp(r.nextDouble() + r.nextDouble());
    return stdchild;
  }

  num mutateProblemWithStrategy(num vector, num stdev) {
    m.Random r = new m.Random();
    var res = vector + stdev * r.nextDouble();
    return res;
  }

  @override
  void mutate() {
    var r = mutateProblemWithStrategy(this.value, this.deviation);
    this.value = r;
    var d = mutateStrategy(this.deviation);
    this.deviation = d;
  }
}
