import "dart:math" as m;

m.Random _rnd = new m.Random();
var randomDouble = _rnd.nextDouble;
int randomIinteger(var i) => _rnd.nextInt(i);

class MinMax {
  num min;
  num max;
  MinMax(this.min, this.max);
}

class Configuration {
  List<MinMax> space;
  List<num> strategy;
  Configuration(this.strategy, this.space);
}

List<double> random_vector(List<MinMax> minmax) {
  m.Random r = new m.Random();
  return minmax.map((i) => i.min + ((i.max - i.min * r.nextDouble())));
}

double random_gaussian({num mean = 0.0, num stdev = 1.0}) {
  double u1 = 0.0;
  double u2 = 0.0;
  double w = 0.0;
  m.Random r = new m.Random();

  do {
    u1 = 2 * r.nextDouble() - 1;
    u2 = 2 * r.nextDouble() - 1;
    w = u1 * u1 + u2 * u2;
  } while (w >= 1);

  w = m.sqrt((-2.0 * m.log(w)) / w);
  return mean + (u2 * w) * stdev;
}

typedef T ZipFun2<T>(T a, T b);
typedef T ZipFun3<T>(T a, T c, T d);

List<T> zip2<T>(List<T> l1, List<T> l2, ZipFun2 f) {
  assert(l1 != null);
  assert(l2 != null);

  var res = new List<T>();
  var len1 = l1.length;
  var len2 = l2.length;
  assert(len1 == len2);
  for (var i; i < len1; i++) {
    res.add(f(l1[i], l2[i]));
  }
  return res;
}

List<T> zip3<T>(List<T> l1, List<T> l2, List<T> l3, ZipFun3 f) {
  assert(l1 != null);
  assert(l2 != null);
  assert(l3 != null);

  var res = new List<T>();
  var len1 = l1.length;
  var len2 = l2.length;
  var len3 = l3.length;
  assert(len1 == len2, len1 == len3);
  for (var i; i < len1; i++) {
    res.add(f(l1[i], l2[i], l3[i]));
  }
  return res;
}
